diff -pruN 0.9.0-6/debian/changelog 0.9.0-6.1/debian/changelog
--- 0.9.0-6/debian/changelog	2023-12-21 14:17:58.000000000 +0000
+++ 0.9.0-6.1/debian/changelog	2024-05-02 16:30:23.000000000 +0000
@@ -1,3 +1,11 @@
+greetd (0.9.0-6.1) unstable; urgency=medium
+
+  * Non-maintainer upload.
+  * Add upstream patch for nix 0.27 (Closes: #1064480)
+  * Tighten build-dependency on nix.
+
+ -- Peter Michael Green <plugwash@debian.org>  Thu, 02 May 2024 16:30:23 +0000
+
 greetd (0.9.0-6) unstable; urgency=medium
 
   * Relax dependency on rpassword (Closes: #1057931).
diff -pruN 0.9.0-6/debian/control 0.9.0-6.1/debian/control
--- 0.9.0-6/debian/control	2023-12-21 14:17:58.000000000 +0000
+++ 0.9.0-6.1/debian/control	2024-05-02 16:26:04.000000000 +0000
@@ -6,7 +6,7 @@ Build-Depends:
  debhelper-compat (= 13),
  dh-cargo,
 # greetd & greetd_ipc
- librust-nix-dev (>= 0.25),
+ librust-nix-0.27-dev,
  librust-pam-sys-dev (>= 0.5.6),
  librust-users-dev (>= 0.11.0),
  librust-serde-derive-dev (>= 1.0),
diff -pruN 0.9.0-6/debian/patches/nix-0.27.patch 0.9.0-6.1/debian/patches/nix-0.27.patch
--- 0.9.0-6/debian/patches/nix-0.27.patch	1970-01-01 00:00:00.000000000 +0000
+++ 0.9.0-6.1/debian/patches/nix-0.27.patch	2024-05-02 16:26:04.000000000 +0000
@@ -0,0 +1,43 @@
+This patch is based on the upstream commit described below, adapted for use
+in the Debian package by Peter Michael Green.
+
+commit 161218164d366482ab7fab9dcc59cbd40623ac2c
+Author: Kenny Levinsen <kl@kl.wtf>
+Date:   Wed Feb 7 15:14:24 2024 +0100
+
+    Update dependencies
+
+diff --git a/greetd/Cargo.toml b/greetd/Cargo.toml
+index c206ac1..3b1446f 100644
+--- a/greetd/Cargo.toml
++++ b/greetd/Cargo.toml
+@@ -14,1 +14,1 @@ repository = "https://git.sr.ht/~kennylevinsen/greetd/"
+-nix = "0.26"
++nix = { version = "0.27", features = ["ioctl", "signal", "user", "fs", "mman"] }
+diff --git a/greetd/src/main.rs b/greetd/src/main.rs
+index b88c6dc..92a53d4 100644
+--- a/greetd/src/main.rs
++++ b/greetd/src/main.rs
+@@ -22,7 +22,7 @@ use crate::{error::Error, session::worker};
+ 
+ async fn session_worker_main(config: config::Config) -> Result<(), Error> {
+     let raw_fd = config.internal.session_worker as RawFd;
+-    let mut cur_flags = unsafe { FdFlag::from_bits_unchecked(fcntl(raw_fd, FcntlArg::F_GETFD)?) };
++    let mut cur_flags = FdFlag::from_bits_retain(fcntl(raw_fd, FcntlArg::F_GETFD)?);
+     cur_flags.insert(FdFlag::FD_CLOEXEC);
+     fcntl(raw_fd, FcntlArg::F_SETFD(cur_flags))?;
+     let sock = unsafe { UnixDatagram::from_raw_fd(raw_fd) };
+diff --git a/greetd/src/session/interface.rs b/greetd/src/session/interface.rs
+index f1d3f04..b31f47f 100644
+--- a/greetd/src/session/interface.rs
++++ b/greetd/src/session/interface.rs
+@@ -99,8 +99,7 @@ impl Session {
+             UnixDatagram::pair().map_err(|e| format!("could not create pipe: {}", e))?;
+ 
+         let raw_child = childfd.as_raw_fd();
+-        let mut cur_flags =
+-            unsafe { FdFlag::from_bits_unchecked(fcntl(raw_child, FcntlArg::F_GETFD)?) };
++        let mut cur_flags = FdFlag::from_bits_retain(fcntl(raw_child, FcntlArg::F_GETFD)?);
+         cur_flags.remove(FdFlag::FD_CLOEXEC);
+         fcntl(raw_child, FcntlArg::F_SETFD(cur_flags))?;
+ 
diff -pruN 0.9.0-6/debian/patches/relax_deps.patch 0.9.0-6.1/debian/patches/relax_deps.patch
--- 0.9.0-6/debian/patches/relax_deps.patch	2023-12-21 14:17:58.000000000 +0000
+++ 0.9.0-6.1/debian/patches/relax_deps.patch	2024-05-02 16:26:04.000000000 +0000
@@ -15,15 +15,4 @@ This patch header follows DEP-3: http://
  getopts = "0.2"
  enquote = "1.1"
 -nix = "0.26"
-+nix = ">=0.26"
---- a/greetd/Cargo.toml
-+++ b/greetd/Cargo.toml
-@@ -11,7 +11,7 @@
- debug = []
- 
- [dependencies]
--nix = "0.26"
-+nix = ">=0.26"
- pam-sys = "0.5.6"
- users = "0.11.0"
- serde = { version = "1.0", features = ["derive"] }
++nix = ">= 0.26"
diff -pruN 0.9.0-6/debian/patches/series 0.9.0-6.1/debian/patches/series
--- 0.9.0-6/debian/patches/series	2023-12-21 14:17:58.000000000 +0000
+++ 0.9.0-6.1/debian/patches/series	2024-05-02 16:26:04.000000000 +0000
@@ -2,3 +2,4 @@ systemd_service_tweaks.patch
 config_tweaks.patch
 relax_deps.patch
 rpassword_6.0_adaptation.patch
+nix-0.27.patch
